Mirror of the gdb-patches mailing list
 help / color / mirror / Atom feed
From: Samuel Bronson <naesten@gmail.com>
To: gdb-patches@sourceware.org
Cc: Tom Tromey <tromey@redhat.com>,
	   Jan Kratochvil <jan.kratochvil@redhat.com>,
	   Doug Evans <dje@google.com>
Subject: [PATCH v5] Resurrect gdb-add-index as a contrib script
Date: Fri, 15 Nov 2013 22:00:00 -0000	[thread overview]
Message-ID: <E1VhQgs-00062h-KF@hydrogen> (raw)
In-Reply-To: <1383519137-26388-1-git-send-email-naesten@gmail.com>

This includes changes made in Fedora's gdb packaging[1], Doug's
robustness patch[2] from before gdb-add-index was dropped, some
corrections, and some more changes Doug accumulated in the
meantime[3].

[1]: http://pkgs.fedoraproject.org/cgit/gdb.git/log/gdb-gdb-add-index-script.patch?id=fe74423b0812bae6d7bb027584e401a2ac37d24d
[2]: https://sourceware.org/ml/gdb-patches/2010-09/msg00130.html
[3]: https://sourceware.org/ml/gdb-patches/2013-11/msg00297.html

It would be a good idea to mention the existance of this script
in (info "(gdb) Index Files"), but I'm boycotting invariant
sections/cover texts because non-free docs are a PITA, so somebody
else would need to do that.

Summary of previous activity:

97924a9 Actual removal
c29c521 Attempted removal (accidentally left gdb-add-index.sh in place)
c2bbed2 Addition
---
 gdb/ChangeLog                |  9 ++++++
 gdb/NEWS                     |  3 ++
 gdb/contrib/gdb-add-index.sh | 69 ++++++++++++++++++++++++++++++++++++++++++++
 3 files changed, 81 insertions(+)
 create mode 100755 gdb/contrib/gdb-add-index.sh

diff --git a/gdb/ChangeLog b/gdb/ChangeLog
index de15879..a93fac8 100644
--- a/gdb/ChangeLog
+++ b/gdb/ChangeLog
@@ -1,3 +1,12 @@
+2013-11-15  Tom Tromey  <tromey@redhat.com>
+	    Jan Kratochvil  <jan.kratochvil@redhat.com>
+	    Doug Evans  <dje@google.com>
+	    Samuel Bronson  <naesten@gmail.com>
+
+	Bring back gdb-add-index as a contrib script.
+	* contrib/gdb-add-index.sh: New file.
+	* NEWS: Note the addition.
+
 2013-11-14  Pedro Alves  <palves@redhat.com>
 
 	* infrun.c (handle_signal_stop): Move STOP_QUIETLY,
diff --git a/gdb/NEWS b/gdb/NEWS
index 3be0073..dd83baa 100644
--- a/gdb/NEWS
+++ b/gdb/NEWS
@@ -32,6 +32,9 @@
   Before, the former would print "<optimized out>", and the latter
   "*value not available*".
 
+* New script contrib/gdb-add-index.sh for adding .gdb_index sections
+  to binaries.
+
 * Python scripting
 
   ** Frame filters and frame decorators have been added.
diff --git a/gdb/contrib/gdb-add-index.sh b/gdb/contrib/gdb-add-index.sh
new file mode 100755
index 0000000..3ef09de
--- /dev/null
+++ b/gdb/contrib/gdb-add-index.sh
@@ -0,0 +1,69 @@
+#! /bin/sh
+
+# Add a .gdb_index section to a file.
+
+# Copyright (C) 2010, 2012-2013 Free Software Foundation, Inc.
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 3 of the License, or
+# (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program.  If not, see <http://www.gnu.org/licenses/>.
+
+# This program assumes gdb and objcopy are in $PATH.
+# If not, or you want others, pass the following in the environment
+GDB=${GDB:=gdb}
+OBJCOPY=${OBJCOPY:=objcopy}
+
+myname="${0##*/}"
+
+if test $# != 1; then
+    echo "usage: $myname FILE" 1>&2
+    exit 1
+fi
+
+file="$1"
+
+if test ! -r "$file"; then
+    echo "$myname: unable to access: $file" 1>&2
+    exit 1
+fi
+
+dir="${file%/*}"
+test "$dir" = "$file" && dir="."
+index="${file}.gdb-index"
+
+rm -f $index
+# Ensure intermediate index file is removed when we exit.
+trap "rm -f $index" 0
+
+$GDB --batch -nx -iex 'set auto-load no' \
+    -ex "file $file" -ex "save gdb-index $dir" || {
+    # Just in case.
+    status=$?
+    echo "$myname: gdb error generating index for $file" 1>&2
+    exit $status
+}
+
+# In some situations gdb can exit without creating an index.  This is
+# not an error.
+# E.g., if $file is stripped.  This behaviour is akin to stripping an
+# already stripped binary, it's a no-op.
+status=0
+
+if test -f "$index"; then
+    $OBJCOPY --add-section .gdb_index="$index" \
+	--set-section-flags .gdb_index=readonly "$file" "$file"
+    status=$?
+else
+    echo "$myname: No index was created for $file" 1>&2
+    echo "$myname: [Was there no debuginfo? Was there already an index?]" 1>&2
+fi
+
+exit $status
-- 
1.8.4.rc3


  parent reply	other threads:[~2013-11-15 21:14 UTC|newest]

Thread overview: 14+ messages / expand[flat|nested]  mbox.gz  Atom feed  top
2013-11-03 22:52 [PATCH] " Samuel Bronson
2013-11-04  2:05 ` Samuel Bronson
2013-11-04 21:17   ` Samuel Bronson
2013-11-07 20:10 ` Jan Kratochvil
2013-11-07 21:54   ` Tom Tromey
2013-11-09  6:23 ` [PATCH v2] " Samuel Bronson
2013-11-09 18:41 ` [PATCH v3] " Samuel Bronson
2013-11-11 19:46   ` Doug Evans
2013-11-15  3:31 ` [PATCH v4] " Samuel Bronson
2013-11-15 10:50   ` Doug Evans
2013-11-15 15:27   ` Jan Kratochvil
2013-11-15 16:38     ` Eli Zaretskii
2013-11-15 22:00 ` Samuel Bronson [this message]
2013-11-16 12:12   ` [PATCH v5] " Jan Kratochvil

Reply instructions:

You may reply publicly to this message via plain-text email
using any one of the following methods:

* Save the following mbox file, import it into your mail client,
  and reply-to-all from there: mbox

  Avoid top-posting and favor interleaved quoting:
  https://en.wikipedia.org/wiki/Posting_style#Interleaved_style

* Reply using the --to, --cc, and --in-reply-to
  switches of git-send-email(1):

  git send-email \
    --in-reply-to=E1VhQgs-00062h-KF@hydrogen \
    --to=naesten@gmail.com \
    --cc=dje@google.com \
    --cc=gdb-patches@sourceware.org \
    --cc=jan.kratochvil@redhat.com \
    --cc=tromey@redhat.com \
    /path/to/YOUR_REPLY

  https://kernel.org/pub/software/scm/git/docs/git-send-email.html

* If your mail client supports setting the In-Reply-To header
  via mailto: links, try the mailto: link
Be sure your reply has a Subject: header at the top and a blank line before the message body.
This is a public inbox, see mirroring instructions
for how to clone and mirror all data and code used for this inbox